program calc_cg_pot
use global_variables
use routines
implicit none

  character(100) :: ifn
  character(5) :: input
  integer :: ia, ib, ic, i_sample, j_sample, n_input
  real*8, dimension(:,:,:), allocatable :: free_energy
  real*8, dimension(:,:), allocatable :: rand_pos
  real*8, dimension(3) :: si, sj
  real*8 :: dr, E

  n_input = IARGC()
  if (n_input .ne. 5 ) then
     stop " must have 5 command line arguments"
  endif

! First input file describes the box, and the second input is the smooth inter-molecular potential
  call getarg( 1, ifn )
  call read_box( ifn )
  !call initialize_potent_table()
  call getarg( 2, ifn )
  call read_potent_table( ifn )
  ! get grid size
 call getarg( 3, input )
 read(input,*) ngrida
call getarg( 4, input )
 read(input,*) ngridb
call getarg( 5, input )
 read(input,*) ngridc



!  do ia = 1, n_table
!    write(*,'(I5, E18.8)') ia, potent_table(ia)
!  enddo

  allocate( free_energy(ngrida,ngridb,ngridc), rand_pos(n_sample,3) )

  do i_sample = 1, n_sample
    call random_number( rand_pos(i_sample,:) )
  enddo

! Sample the grid
  do ia = 1, ngrida
    do ib = 1, ngridb
      do ic = 1, ngridc
!        write(*,'(3I5)') ia, ib, ic
        if ( ia == 1 .and. ib == 1 .and. ic == 1 ) then
          free_energy(ia,ib,ic) = 1000.0d0
          goto 999
        endif
        free_energy( ia, ib, ic ) = 0.0d0
        do i_sample = 1, n_sample
          si(1) = rand_pos(i_sample,1) / ngrida
          si(2) = rand_pos(i_sample,2) / ngridb
          si(3) = rand_pos(i_sample,3) / ngridc
          do j_sample = 1, n_sample
            sj(1) = rand_pos(j_sample,1) / ngrida + (ia-1d0) / ngrida
            sj(2) = rand_pos(j_sample,2) / ngridb + (ib-1d0) / ngridb
            sj(3) = rand_pos(j_sample,3) / ngridc + (ic-1d0) / ngridc
            dr = pbc_dr( si, sj )
            E = potential( dr )
!write(*,'(3E16.6)') dexp(-E/temp/8.314d0*1000d0), E, dr
            free_energy(ia,ib,ic) = free_energy(ia,ib,ic) + dexp(-E/temp/8.314d0*1000d0)
          enddo
        enddo
        free_energy(ia,ib,ic) = free_energy(ia,ib,ic) / n_sample**2
        free_energy(ia,ib,ic) = -8.314*temp/1000d0 * log( free_energy(ia,ib,ic) )
999     continue
        si(:) = 0.0d0
        sj(1) = (ia-1.0d0)/ngrida
        sj(2) = (ib-1.0d0)/ngridb
        sj(3) = (ic-1.0d0)/ngridc
        dr = pbc_dr( si, sj )
        E = potential( dr )
        write(*,'(3I5,2E15.6)') ia, ib, ic, E
      enddo
      write(*,*)
    enddo
  enddo

! output
!  do ia = 1, ngrida
!    do ib = 1, ngridb
!      do ic = 1, ngridc
!        si(:) = 0.0d0
!        sj(1) = (ia-1.0d0)/ngrida
!        sj(2) = (ib-1.0d0)/ngridb
!        sj(3) = (ic-1.0d0)/ngridc
!        dr = pbc_dr( si, sj )
!        E = potential( dr )
!        write(*,'(3I5,2F15.6)') ia, ib, ic, free_energy(ia,ib,ic), E
!      enddo
!      write(*,*)
!    enddo
!  enddo

end program calc_cg_pot
