module global_variables

! NOTE: MAX_N_PART is the maximum number of adsorbed molecules on the lattice
! 100000 should be way more than needed for any reasonably sized MOF
integer, parameter :: MAX_FN=100 , MAX_N_PART=100000
real*8, parameter :: pi=3.14159265

! global data
real*8  :: cube_volume, tot_volume
integer,dimension(3) :: grid_size
real*8,dimension(:,:,:,:), allocatable :: xyz_grid
real*8,dimension(:,:,:), allocatable :: avg_boltz_grid, lattice_energy, pair_int_grid


! simulation parameters
integer,parameter :: n_equil=10000000, n_steps = 10000000,n_output = 1000000
real*8,parameter:: gcmc_ins_rm = .4

real*8  :: temp  ! this is read in from the lattice free energy grid
real*8 :: mass_solute  ! this is read in from command line
real*8 :: chem_potential ! this is read in from command line



integer,dimension(MAX_N_PART,3) :: particle_lattice_index
integer  :: n_particles


end module global_variables
