#!/usr/bin/perl

$energy_conv = 1/ 4.184;       # kJ/mol to kcal/mol
$equil=.2; # fraction of trajectory to drop as equilibration
$blocks=5; # blocks for block averaging

$ifile=$ARGV[0];


    my@volume;my@potential;

# get volume, energy information

open ifile,$ifile,or die;
$flag_t=1;$flag_p=1;
$small=.0001;

do {$_=<ifile>;
if (/temperature/)
{ @array=split; $temperature=$array[1];}
if (/molecules/)
{ @array=split;$molecules=$array[1];}
} until (/long range/);


 <ifile>;
while(<ifile>)
{
 <ifile>;<ifile>; <ifile>;$_=<ifile>;@array=split;
 push(@potential,$array[2]);
<ifile>; <ifile>;<ifile>;<ifile>;
}

close(ifile);


# now block average volume and potential
$nconfig=@potential;
$nequil=int($equil*$nconfig);
$nblock=int(($nconfig-$nequil)/$blocks);

my@blockaverage;$average_v=0;$average_p=0;
for(my$k=0;$k<$blocks;$k++)
{
    $index=$nequil + $k * $nblock ; $sumv=0;$sump=0;
    for(my$l=0;$l<$nblock;$l++)
{
    $index1=$index+$l ;
    $sump=$sump+$potential[$index1];
}
$sump=$sump/$nblock;

$average_p=$average_p+$sump;

 push(@blockaverage,$sump  )
}
$average_p=$average_p/$blocks;


$deltah = ( .008314 * $temperature  - $average_p / $molecules ) * $energy_conv;

#print"$average_v\n";
#print"$average_p\n";

$max_dev_v=0;$max_dev_p=0;
for(my$k=0;$k<$blocks;$k++)
{
    $p_dev=abs(( $blockaverage[$k] - $average_p ) / $average_p  );

    if ( $p_dev > $max_dev_p ) { $max_dev_p = $p_dev }


  #print"$k  $dens \n"
  }

print" temperature is $temperature , number of molecules $molecules \n";
print" enthalpy vap     max deviation from block average\n";
print"$deltah   $max_dev_p\n";


