#!/usr/bin/perl

# this script evaluates the test calculation "acetone_STP_SAPTFF_nodrudes"
$job="acetone_STP_SAPTFF";
$file_benchmark="RESULTS_BENCHMARK";
$file_test="drude_position_output";
$molecules=250;
$shells_per_molecule=4;

my@drude_position_benchmark;
my@drude_position_test;


#************* force data from benchmark file

open ifile, $file_benchmark, or die ;

<ifile>;<ifile>;<ifile>;<ifile>;<ifile>;
for(my$i=0;$i<$molecules;$i++)
{ my@temp=();
    for(my$j=0;$j<$shells_per_molecule;$j++)
{ 
    $_=<ifile>;@array=split;$_=<ifile>;@array1=split; push(@temp,[$array[2],$array[3],$array1[0]]);
 if ( ($array[0] != ($i+1) ) or ($array[1] != ($j+1) ) )
{ die "error reading file $file_benchmark for job $job \n" }
}
push(@drude_position_benchmark,[@temp])
}


close(ifile);

#************* force data from test job file

open ifile, $file_test, or die ;

<ifile>;<ifile>;<ifile>;<ifile>;<ifile>;<ifile>;
for(my$i=0;$i<$molecules;$i++)
{ my@temp=();
    for(my$j=0;$j<$shells_per_molecule;$j++)
{
    $_=<ifile>;@array=split;$_=<ifile>;@array1=split; push(@temp,[$array[2],$array[3],$array1[0]]);
 if ( ($array[0] != ($i+1) ) or ($array[1] != ($j+1) ) )
{ die "error reading file $file_test for job $job \n" }
}
push(@drude_position_test,[@temp])
}

close(ifile);

# now find maximum drude displacement, maximum displacement error and average drude displacement and average displacement difference
# electrostatics
$max=-1;$sum=0;$count=0;
$max_diff=-1;$sum_diff=0;

for(my$i=0;$i<@drude_position_benchmark;$i++)
{
    for(my$j=0;$j<@{$drude_position_benchmark[$i]};$j++)
{
    $r1 = displacement( @{$drude_position_benchmark[$i][$j]} ) ;
    $r2 = delta_displacement( @{$drude_position_benchmark[$i][$j]} , @{$drude_position_test[$i][$j]} ) ;
    
    if ( $r1 > $max ) { $max = $r1 }
    if ( $r2 > $max_diff ) { $max_diff = $r2 }

    $sum = $sum + $r1;
    $sum_diff = $sum_diff + $r2 ;

    $count=$count+1
}
}
$average1 = $sum / $count;
$average2 = $sum_diff / $count;

print"maximum drude oscillator displacement $max Angstroms\n";
print"average drude oscillator displacement is $average1 Angstroms\n";
print"maximum difference in drude oscillator displacement for test job is $max_diff Angstroms\n";
print"average difference in drude oscillator displacement for test job is $average2 Angstroms\n";


sub displacement{
    $x = $_[0];$y = $_[1];$z = $_[2];

    $dist = sqrt( $x**2 + $y**2 + $z**2 ) ;
    return $dist }

sub delta_displacement{
    $x1 = $_[0];$y1 = $_[1];$z1 = $_[2];
    $x2 = $_[3];$y2 = $_[4];$z2 = $_[5];

    $dist = sqrt( ($x1-$x2)**2 +  ($y1-$y2)**2 + ($z1-$z2)**2 ) ;
    return $dist }
    
