#!/bin/bash

# this script runs the test job, and compares the output to the Benchmark data

NAME="h2_MTV_AH_77K_800torr"
output="${NAME}.e*"
script="evaluate_test.pl"

TARGET=run.sh
suf1=".out"
suf2=".out1"
outfile="$NAME$suf1"
outfile1="$NAME$suf2"
clean="${NAME}.*"
rm $clean

cat >> $TARGET << EOF
#!/bin/bash
#PBS -N $NAME -l nodes=1:ppn=8
export OMP_STACKSIZE=20M
./main_mc h2.conf mof_AH_relabeled_2x2x2.fconf h2_mofAH.pmt simulation_parameters.pmt $outfile $outfile1
EOF

qsub -d `pwd` $TARGET
rm $TARGET

flag=0

while [ $flag -eq 0 ] ; do

if [ -e $output ] ;
then
flag=1
# give time to fully write file
sleep 1
else
sleep 5
fi
done


echo "results for test job $NAME"
./${script}