#!/bin/bash

# this script runs the test job, and compares the output to the Benchmark data

NAME="CO2_MOF5_298K_15bar_SAPTFF_nodrudes"
output="force_output"
script="evaluate_test.pl"

TARGET=run.sh
suf1=".out"
suf2=".out1"
outfile="$NAME$suf1"
outfile1="$NAME$suf2"

rm $output

cat >> $TARGET << EOF
#!/bin/bash
#PBS -N $NAME -l nodes=1:ppn=8
export OMP_STACKSIZE=20M
./main_mc co2.conf mof5_labeled.fconf mof5_co2.pmt simulation_parameters.pmt $outfile $outfile1 > $output
EOF

qsub -d `pwd` $TARGET
rm $TARGET

flag=0

while [ $flag -eq 0 ] ; do

if [ -e $output ] ;
then
flag=1
# give time to fully write file
sleep 3
else
sleep 5
fi
done

#clean up unnecessary output files
rm ${NAME}*

echo "results for test job $NAME"
./${script}