#!/usr/bin/perl

# this script evaluates the test calculation "acetone_STP_SAPTFF_nodrudes"
$job="acetone_STP_SAPTFF_nodrudes";
$file_benchmark="RESULTS_BENCHMARK";
$file_test="force_output";
$molecules=250;
$atoms_per_molecule=10;

my@electrostatic_force_benchmark;
my@electrostatic_force_test;
my@lennardjones_force_benchmark;
my@lennardjones_force_test;

#************* force data from benchmark file

open ifile, $file_benchmark, or die ;

<ifile>;<ifile>;<ifile>;<ifile>;
for(my$i=0;$i<$molecules;$i++)
{ my@temp=();
    for(my$j=0;$j<$atoms_per_molecule;$j++)
{ 
    $_=<ifile>;@array=split;$_=<ifile>;@array1=split; push(@temp,[$array[2],$array[3],$array1[0]]);
 if ( ($array[0] != ($i+1) ) or ($array[1] != ($j+1) ) )
{ die "error reading file $file_benchmark for job $job \n" }
}
push(@electrostatic_force_benchmark,[@temp])
}
<ifile>;<ifile>;
for(my$i=0;$i<$molecules;$i++)
{ my@temp=();
    for(my$j=0;$j<$atoms_per_molecule;$j++)
{ 
    $_=<ifile>;@array=split;$_=<ifile>;@array1=split; push(@temp,[$array[2],$array[3],$array1[0]]);
 if ( ($array[0] != ($i+1) ) or ($array[1] != ($j+1) ) )
{ die "error reading file $file_benchmark for job $job \n" }
}
push(@lennardjones_force_benchmark,[@temp])
}

close(ifile);

#************* force data from test job file

open ifile, $file_test, or die ;

<ifile>;<ifile>;<ifile>;<ifile>;<ifile>;<ifile>;<ifile>;<ifile>;
for(my$i=0;$i<$molecules;$i++)
{ my@temp=();
    for(my$j=0;$j<$atoms_per_molecule;$j++)
{
    $_=<ifile>;@array=split;$_=<ifile>;@array1=split; push(@temp,[$array[2],$array[3],$array1[0]]);
 if ( ($array[0] != ($i+1) ) or ($array[1] != ($j+1) ) )
{ die "error reading file $file_test for job $job \n" }
}
push(@electrostatic_force_test,[@temp])
}
<ifile>;<ifile>;
for(my$i=0;$i<$molecules;$i++)
{ my@temp=();
    for(my$j=0;$j<$atoms_per_molecule;$j++)
{
    $_=<ifile>;@array=split;$_=<ifile>;@array1=split; push(@temp,[$array[2],$array[3],$array1[0]]);
 if ( ($array[0] != ($i+1) ) or ($array[1] != ($j+1) ) )
{ die "error reading file $file_test for job $job \n" }
}
push(@lennardjones_force_test,[@temp])
}

close(ifile);

# now find maximum force difference and average difference
# electrostatics
$max=-1;$sum=0;$count=0;

for(my$i=0;$i<@electrostatic_force_benchmark;$i++)
{
    for(my$j=0;$j<@{$electrostatic_force_benchmark[$i]};$j++)
{
    for(my$k=0;$k<3;$k++)
{
    $diff = abs( $electrostatic_force_benchmark[$i][$j][$k] - $electrostatic_force_test[$i][$j][$k] ) ;
    if ( $diff > $max ) { $max = $diff }

    $sum = $sum + $diff;
    $count=$count+1
	     }
}
}
$average = $sum / $count;
print"max diff for electrostatic force is  $max \n";
print"average diff is $average \n";

$max=-1;$sum=0;$count=0;

for(my$i=0;$i<@lennardjones_force_benchmark;$i++)
{
    for(my$j=0;$j<@{$lennardjones_force_benchmark[$i]};$j++)
{
    for(my$k=0;$k<3;$k++)
{
    $diff = abs( $lennardjones_force_benchmark[$i][$j][$k] - $lennardjones_force_test[$i][$j][$k] ) ;
    if ( $diff > $max ) { $max = $diff }

    $sum = $sum + $diff;
    $count=$count+1
	     }
}
}
$average = $sum / $count;
print"max diff for lennard jones force is  $max \n";
print"average diff is $average \n";
