#!/usr/bin/python
import sys

# this script creates a .sym symmetry file for use in the lattice model code for a particular MOF, from the symmetry operations found in a .cif file
# use a list of symmetry operations from a .cif file as input

# so if cif file looks like
#
#   lines
#    ....
# loop_
# _symmetry_equiv_pos_site_id
# _symmetry_equiv_pos_as_xyz
# 1 x,y,z
# 2 y,-x,-z
# ...
# 48 0.500+z,0.500+y,0.500+x
#
# input file should contain lines
#
# 1 x,y,z
# 2 y,-x,-z
# ...
# 48 0.500+z,0.500+y,0.500+x

ifile = file( sys.argv[1], 'r' )

lines = []
for line in ifile:
        words = line.split()
        if len(words) > 0 :
                lines.append(line)
ifile.close()

print len(lines)

for line in lines:
        words = line.split(',')
        print '',
        for word in words:
                # delete spaces in the string
                tmp = word.split()
                word = ''
                for i in range(len(tmp)):
                        word = word + tmp[i]
                cx = 0.0
                if 'x' in word:
                        index = word.index('x')
                        if index > 0 and word[index-1] == '-' :
                                cx = -1.0
                        else:
                                cx = 1.0
                cy = 0.0
                if 'y' in word:
                        index = word.index('y')
                        if index > 0 and word[index-1] == '-' :
                                cy = -1.0
                        else:
                                cy = 1.0
                cz = 0.0
                if 'z' in word:
                        index = word.index('z')
                        if index > 0 and word[index-1] == '-' :
                                cz = -1.0
                        else:
                                cz = 1.0
                c0 = 0.0
                if '/' in word:
                        index = word.index('/')
                        a = word[index-1]
                        b = word[index+1]
                        c0 = float(a)/float(b)
                        if index > 1 and word[index-2] == '-' :
                                c0 = -c0
                print '%9.6f%10.6f%10.6f%10.6f'%(cx,cy,cz,c0),
        print

